#if !defined(AFX_WAVEFILE_H__1233C4C0_DD15_11D2_AA57_00C00C9003E0__INCLUDED_)
#define AFX_WAVEFILE_H__1233C4C0_DD15_11D2_AA57_00C00C9003E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WaveFile.h : wb_[ t@C
//

#include <mmsystem.h>

#define	MAXWAVEHDR	8
#define	MAXWAVEBUF	(16 * 1024)
#define	MAXVOLUME	1000

/////////////////////////////////////////////////////////////////////////////
// CWaveFile EBhE

class CWaveFile : public CWnd
{
// RXgNV
public:
	CWaveFile(CWnd *Wnd);

// Agr[g
public:

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(CWaveFile)
	//}}AFX_VIRTUAL

// Cve[V
public:
	int DrawLine(CDC *pDC, RECT *pRect, DWORD entry);
	CWnd *pWnd;
	HMMIO hmmio;
	CString fileName;
	CString listName;
	HWAVEOUT hWaveOut;
	MMCKINFO mmckinfoParent;
	MMCKINFO mmckinfoSubchunk;
	WAVEFORMATEX waveFormat;
	DWORD waveSize;
	DWORD playSize;
	int stopFlag;
	int maxLevel;
	int volLevel;
	int FadeIn;
	int FadeOut;
	DWORD SkipIn;
	DWORD SkipOut;
	WAVEHDR waveHdrTab[MAXWAVEHDR];
	char waveBuffer[MAXWAVEHDR][MAXWAVEBUF];
	int OpenFile(LPCSTR file);
	void CloseFile();
	void VolumeCalc(DWORD pos, int len, char *buff);
	int InitFile(LPCSTR file);
	int PlayStart();
	void PlayEnd();
	int PlayStatus();
	int MaxLevel();
	void RegLevel();
	int SaveFile();
	int CreateFile(LPCSTR file);
	void AscendFile();
	int WriteData(void *buff, int len);
	int ReadData(void *buff, int len);
	void SetSkipIn(DWORD val);
	void SetSkipOut(DWORD val);
	virtual ~CWaveFile();
	inline int GetLevel(int val) { if ( val < 0 ) val = 0 - val; return val; }

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CWaveFile)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
        afx_msg void OnWaveOutData(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_WAVEFILE_H__1233C4C0_DD15_11D2_AA57_00C00C9003E0__INCLUDED_)
