// VolCtrl.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WavList.h"
#include "VolCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVolCtrl _CAO


CVolCtrl::CVolCtrl(CWnd* pParent /*=NULL*/)
	: CDialog(CVolCtrl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVolCtrl)
	m_Volume = 1000;
	m_FadeIn = 0;
	m_FadeOut = 0;
	//}}AFX_DATA_INIT
}


void CVolCtrl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVolCtrl)
	DDX_Slider(pDX, IDC_VOLUME, m_Volume);
	DDX_Slider(pDX, IDC_FADE_IN, m_FadeIn);
	DDX_Slider(pDX, IDC_FADE_OUT, m_FadeOut);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVolCtrl, CDialog)
	//{{AFX_MSG_MAP(CVolCtrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVolCtrl bZ[W nh

BOOL CVolCtrl::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CSliderCtrl *pSlider;

	pSlider = (CSliderCtrl *)GetDlgItem(IDC_FADE_IN);
	pSlider->SetRange(0, 10, TRUE);
	pSlider->SetPos(m_FadeIn);

	pSlider = (CSliderCtrl *)GetDlgItem(IDC_FADE_OUT);
	pSlider->SetRange(0, 10, TRUE);
	pSlider->SetPos(m_FadeOut);

	pSlider = (CSliderCtrl *)GetDlgItem(IDC_VOLUME);
	pSlider->SetRange(0, 2000, TRUE);
	pSlider->SetTicFreq(100);
	pSlider->SetPos(m_Volume);

	return FALSE;
}
